Qt 5.9 | Qt 3D | C++ Classes | QScene2D

Qt 5.9.9 Reference Documentation

# QScene2D Class

(Qt3DRender::Quick::QScene2D)

This class enables rendering qml into a texture, which then can be used as a part of 3D scene. More...

Header: | #include <Qt3DQuickScene2D/QScene2D>
qmake: | QT += 3dquickscene2d
Since: | Qt 5.9
Instantiated By: | Scene2D
Inherits: | Qt3DCore::QNode

- List of all members, including inherited members

## Public Types

enum | RenderPolicy { Continuous, SingleShot }

## Properties

- item : QQuickItem *
- mouseEnabled : bool
- output : Qt3DRender::QRenderTargetOutput *
- renderPolicy : QScene2D::RenderPolicy

- 3 properties inherited from Qt3DCore::QNode

## Public Functions

| QScene2D(Qt3DCore::QNode *parent = nullptr)
void | addEntity(Qt3DCore::QEntity *entity)
QVector<Qt3DCore::QEntity *> | entities()
bool | isMouseEnabled() const
QQuickItem * | item() const
Qt3DRender::QRenderTargetOutput * | output() const
void | removeEntity(Qt3DCore::QEntity *entity)
QScene2D::RenderPolicy | renderPolicy() const

- 11 public functions inherited from Qt3DCore::QNode

## Public Slots

void | setItem(QQuickItem *item)
void | setMouseEnabled(bool enabled)
void | setOutput(Qt3DRender::QRenderTargetOutput *output)
void | setRenderPolicy(QScene2D::RenderPolicy policy)

- 3 public slots inherited from Qt3DCore::QNode

## Signals

void | itemChanged(QQuickItem *item)
void | mouseEnabledChanged(bool enabled)
void | outputChanged(Qt3DRender::QRenderTargetOutput *output)
void | renderPolicyChanged(QScene2D::RenderPolicy policy)

- 4 signals inherited from Qt3DCore::QNode

### Additional Inherited Members

- 2 protected functions inherited from Qt3DCore::QNode

## Detailed Description

This class enables rendering qml into a texture, which then can be used as a part of 3D scene.

This class uses QQuickRenderControl to render the given QQuickItem into an offscreen surface, which is attached to a texture provided by the user. This allows the component to directly render into the texture without intermediate copy and the user to freely specify how the texture is used in the 3D scene.

The entities using the QScene2D can be associated with the class to enable interaction with the item; if an entity has a QObjectPicker component, the pick events from that picker are sent to the QScene2D and converted to mouse events and finally sent to the item.

## Member Type Documentation

### enum QScene2D::RenderPolicy

This enum type describes types of render policies available.

Constant | Value | Description
--- | --- | ---
`Qt3DRender::Quick::QScene2D::Continuous` | `0` | The Scene2D is rendering continuously. This is the default render policy.
`Qt3DRender::Quick::QScene2D::SingleShot` | `1` | The Scene2D renders to the texture only once after which the resources allocated for rendering are released.

## Property Documentation

### item : QQuickItem *

Holds the QQuickItem, which is rendered by QScene2D to the texture.

Access functions:

QQuickItem * | item() const
void | setItem(QQuickItem *item)

Notifier signal:

void | itemChanged(QQuickItem *item)

### mouseEnabled : bool

Holds whether mouse events are enabled for the rendered item. The mouse events are generated from object picking events of the entities added to the QScene2D. Mouse is enabled by default.

Note: Events are delayed by one frame due to object picking happening in the backend.

Access functions:

bool | isMouseEnabled() const
void | setMouseEnabled(bool enabled)

Notifier signal:

void | mouseEnabledChanged(bool enabled)

### output : Qt3DRender::QRenderTargetOutput *

Holds the QRenderTargetOutput, which specifies where the QScene2D is rendering to.

Access functions:

Qt3DRender::QRenderTargetOutput * | output() const
void | setOutput(Qt3DRender::QRenderTargetOutput *output)

Notifier signal:

void | outputChanged(Qt3DRender::QRenderTargetOutput *output)

### renderPolicy : QScene2D::RenderPolicy

Holds the render policy of this Scene2D.

Access functions:

QScene2D::RenderPolicy | renderPolicy() const
void | setRenderPolicy(QScene2D::RenderPolicy policy)

Notifier signal:

void | renderPolicyChanged(QScene2D::RenderPolicy policy)

## Member Function Documentation

### QScene2D::QScene2D(Qt3DCore::QNode *parent = nullptr)

The constructor creates a new QScene2D instance with the specified parent.

### void QScene2D::addEntity(Qt3DCore::QEntity *entity)

Adds an entity to the the QScene2D object. If the entities have QObjectPicker, the pick events from that entity are sent to QScene2D and converted to mouse events.

### QVector<Qt3DCore::QEntity *> QScene2D::entities()

Retrieve entities associated with the QScene2D.

### void QScene2D::removeEntity(Qt3DCore::QEntity *entity)

Removes an entity from the the QScene2D object.